% Extract a single seam on a welding image and display
%
% Jiansheng Chen, Guangda Su and Shoubin Xiang, 
% Robust Welding Seam Tracking using  Image Seam 
% Extraction, Science and Technology of Welding and 
% Joining, Vol. 17, No. 2, Feb. 2012.
%
%01-10-12, Jiansheng Chen

function singleseam(I)
    
    I = im2double(I);
    try
        I = rgb2gray(I);
    catch exception
    end
    
    minpath = extractseam(exp(-I*3));
    img = zeros(size(I,1), size(I,2), 3);
    img(:,:,1) = I;
    img(:,:,2) = I;
    img(:,:,3) = I;
    
    for i = 1:length(minpath)
        img(i, minpath(i), 1) = 1;
        img(i, minpath(i), 2) = 0;
        img(i, minpath(i), 3) = 0;
    end

    figure('name', 'Single seam extraction');
    imshow(img);
    
end